﻿#region Copyright Syncfusion Inc. 2001 - 2012
// Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.Mvc.Schedule;
using samples.Models;
using Syncfusion.Mvc.Shared;
using System.Collections;

namespace samples.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(SchedulePropertiesModel scheduleModel, string ResourceDDL)
        {
            ViewBag.Message = "Welcome to ASP.NET MVC";
           
            if (ResourceDDL == null || ResourceDDL == "")
            {
                ResourceDDL = "1";
            }
            string ResourceIDs = ResourceDDL.Replace(' ', ',');
            ViewData["resources"] = ResourceList(ResourceIDs);
            ViewData["data"] = FilterScheduleData(ResourceIDs);


            ViewData["ScheduleModel"] = scheduleModel;
            ViewData["data"] = EntitiesAppointments;


            return View();
        }
        /// <summary>
        /// get request and redirect to Action Result
        /// </summary>
        /// <param name="args"></param>
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Index(Params args, Schedule scheduleObject)
        {
            int intMax = EntitiesAppointments.Count > 0 ? EntitiesAppointments.Max(p => p.Id) : 1;
            ActionResult result;
            scheduleObject.SetCurrentCultureInfo();

            if (args.CurrentAction == "Save")
            {
                DateTime startTime = Convert.ToDateTime(args.StartTime);
                DateTime endTime = Convert.ToDateTime(args.EndTime);
                Appointment appoint = new Appointment()
                {
                    Id = intMax + 1,
                    StartTime = startTime,
                    EndTime = endTime,
                    Subject = args.Subject,
                    Location = args.Location,
                    Description = args.Description,
                    Owner = args.Owner,
                    Priority = args.Priority,
                    Recurrence = Convert.ToByte(args.Recurrence),
                    RecurrenceType = args.RecurrenceType,
                    RecurrenceTypeCount = Convert.ToInt16(args.RecurrenceTypeCount),
                    Remainder = args.Reminder,
                    Catagorize = args.Categorize,
                    AllDay = args.AllDay,
                    RecurrenceEndDate = args.RecurrenceEnd != null ? Convert.ToDateTime(args.RecurrenceEnd) : endTime,
                    RecurrenceStartDate = args.RecurrenceStart != null ? Convert.ToDateTime(args.RecurrenceStart) : startTime,
                    RecurrenceRule = args.RecurrenceRules
                };

                EntitiesAppointments.Add(appoint);
            }
            result = EntitiesAppointments.ScheduleActions<ScheduleHtmlActionResult>();
            return result;
        }
        public ActionResult About()
        {
            return View();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="model"></param>
        /// <param name="ResourceDDL"></param>
        /// <returns></returns>
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult SubmitButton(SchedulePropertiesModel model, string ResourceDDL)
        {
            
            return View("Index", model);
        }

        private List<Appointment> FilterScheduleData(string ResourceIDs)
        {
            var query = EntitiesAppointments.Where(p => ResourceIDs.Contains(p.Owner.ToString()));
            return query.ToList();
        }

        private List<Appointment> FilterAppointment(int OwnerId)
        {
            List<Appointment> appointmentList = EntitiesAppointments;
            appointmentList = EntitiesAppointments.Where(app => app.Owner == OwnerId).ToList();
            return appointmentList;
        }
        private List<ScheduleResource> ResourceList(string ids)
        {
            List<ScheduleResource> _rList = new List<ScheduleResource>();
            foreach (var ritem in ids.Split(','))
            {
                switch (ritem)
                {
                    case "1":
                        {
                            ScheduleResource Resource1 = new ScheduleResource()
                            {
                                ResourceID = 1,
                                ResourceName = "John",
                            };
                            _rList.Add(Resource1);
                            break;
                        }
                    case "2":
                        {
                            ScheduleResource Resource2 = new ScheduleResource()
                            {
                                ResourceID = 2,
                                ResourceName = "Peterson",
                            };
                            _rList.Add(Resource2);
                            break;
                        }
                    case "3":
                        {
                            ScheduleResource Resource3 = new ScheduleResource()
                            {
                                ResourceID = 3,
                                ResourceName = "Richard",
                            };
                            _rList.Add(Resource3);
                            break;
                        }
                    default:
                        break;
                }
            }
            return _rList;
        }

        private List<Appointment> EntitiesAppointments
        {
            get
            {
                AppDomain.CurrentDomain.SetData("SQLServerCompactEditionUnderWebHosting", true);
                List<Appointment> appointmentList = Session["Appointments"] as List<Appointment>;
                MyNorthwindEntities EDM = new MyNorthwindEntities();
                if (appointmentList == null)
                {
                    appointmentList = new List<Appointment>();
                    appointmentList = EDM.Appointments.ToList();
                    Session["Appointments"] = appointmentList;
                }

                return appointmentList;
            }
        }
    }
}
